Index: XIOS/dev/dev_trunk_omp/src/filter/source_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/source_filter.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/source_filter.cpp	(revision 1680)
@@ -71,17 +71,11 @@
       packet->field = this->field;
       
-      
       if(CXios::isClient) std::cout<<"source filter tag = "<<this->tag<<" start = "<<start_graph<<" end = "<<end_graph<<std::endl;
     
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
-
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "Source Filter "+ this->field->getId();
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 0;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = packet->timestamp;
-
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge>;
+      CWorkflowGraph::allocNodeEdge();
+
+      CWorkflowGraph::addNode(this->filterID, "Source Filter ", 1, 1, 0, packet);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->recordXiosAttributes();
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].field_id = this->field->getId();
 
       CWorkflowGraph::build_begin = true;
Index: XIOS/dev/dev_trunk_omp/src/filter/spatial_transform_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/spatial_transform_filter.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/spatial_transform_filter.cpp	(revision 1680)
@@ -9,4 +9,5 @@
 #endif
 #include "workflow_graph.hpp"
+#include "file.hpp"
 namespace xios
 {
@@ -184,21 +185,12 @@
     {
       this->filterID = InvalidableObject::filterIdGenerator++;
-      int edgeID = InvalidableObject::edgeIdGenerator++;
-    
-      std::cout<<"CSpatialTransformFilter::apply filter tag = "<<tag<<" start = "<<start_graph<<" end = "<<end_graph<<std::endl;
-    
-
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
-
-
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "Spatial Transform Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 6;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
-
-
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
+      int edgeID = InvalidableObject::edgeIdGenerator++;    
+
+      CWorkflowGraph::allocNodeEdge();
+
+      CWorkflowGraph::addNode(this->filterID, "Spatial Transform Filter", 4, 1, 1, data[0]);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = field->recordXiosAttributes();
+      if(field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +field->file->recordXiosAttributes();
+
 
       if(CWorkflowGraph::build_begin)
@@ -229,5 +221,6 @@
       if (0 != packet->data.numElements())
         (packet->data)(0) = defaultValue;
-      apply(data[0]->data, packet->data, this->filterID);
+      if(building_graph) apply(data[0]->data, packet->data, this->filterID);
+      else apply(data[0]->data, packet->data);
     }
 
@@ -354,5 +347,8 @@
         int srcRank = itRecv->first;
 
-        if(filterID >=0) (*CWorkflowGraph::mapFilters_ptr_with_info)[filterID].transform_type = (*itAlgo)->getName();
+        if(filterID >=0)
+        {
+           (*CWorkflowGraph::mapFilters_ptr_with_info)[filterID].filter_name = (*itAlgo)->getName();
+        } 
         if (srcRank != rank)
         {
Index: XIOS/dev/dev_trunk_omp/src/filter/store_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/store_filter.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/store_filter.cpp	(revision 1680)
@@ -3,4 +3,5 @@
 #include "grid.hpp"
 #include "timer.hpp"
+#include "file.hpp"
 
 namespace xios
@@ -98,16 +99,11 @@
       int edgeID = InvalidableObject::edgeIdGenerator++;
 
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+      CWorkflowGraph::allocNodeEdge();
+ 
+      CWorkflowGraph::addNode(this->filterID, "Store Filter", 4, 1, 1, data[0]);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->recordXiosAttributes();
+      if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->recordXiosAttributes();
 
-
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "Store Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 4;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
-
-      if(CXios::isClient) std::cout<<"CStoreFilter::apply filter tag = "<<this->tag<<std::endl;
+      // if(CXios::isClient) std::cout<<"CStoreFilter::apply filter tag = "<<this->tag<<std::endl;
 
       if(CXios::isClient && CWorkflowGraph::build_begin) 
Index: XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.cpp	(revision 1680)
@@ -3,4 +3,5 @@
 #include "calendar_util.hpp"
 #include "workflow_graph.hpp"
+#include "file.hpp"
 
 namespace xios
@@ -28,4 +29,5 @@
 //    , nextOperationDate(initDate + opFreq + this->samplingOffset)
     , isFirstOperation(true)
+    , temp_op(opId)
   {
   }
@@ -34,38 +36,16 @@
   {
     bool building_graph=this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
-   
+
     if(building_graph)
     {
-      if(this->filterIDoutputs.size()==0) this->filterID = InvalidableObject::filterIdGenerator++;
       int edgeID = InvalidableObject::edgeIdGenerator++;
-      
-
-      std::cout<<"CTemporalFilter::apply filter tag = "<<this->tag<<" start = "<<this->start_graph<<" end = "<<this->end_graph<<std::endl;
-
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
+
+      CWorkflowGraph::allocNodeEdge();
 
       if(CWorkflowGraph::build_begin)
       {
-
-        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
-
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
-      }
-      
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
-
-      if(this->filterIDoutputs.size()==0)
-      {
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "Temporal Filter";   
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 3;   
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;   
-        // (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = (initDate + nbOperationDates*opFreq - samplingFreq + offsetMonth + offsetAllButMonth) / data[0]->date +1 ;   
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb =-1;   
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;   
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;   
-      }
-
-
-      this->filterIDoutputs.push_back(data[0]->src_filterID); 
+        CWorkflowGraph::addEdge(edgeID, -1, data[0]);        
+      }
+      this->filterIDoutputs_pair.push_back(make_pair(edgeID, data[0]->src_filterID)); 
     }
     
@@ -101,4 +81,26 @@
       if (outputResult)
       {
+        if(building_graph)
+        {
+          this->filterID = InvalidableObject::filterIdGenerator++;
+          CWorkflowGraph::addNode(this->filterID, "Temporal Filter\\n("+this->temp_op+")", 5, 1, 0, data[0]);   
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].transform_type = this->temp_op;   
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].inputs_complete = true ;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->recordXiosAttributes();
+          if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->recordXiosAttributes();
+
+
+          for(int i=0; i<this->filterIDoutputs_pair.size(); i++)
+          {
+            (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterIDoutputs_pair[i].second].filter_filled = 0 ;  
+            (*CWorkflowGraph::mapFieldToFilters_ptr_with_info)[this->filterIDoutputs_pair[i].first].to = this->filterID ;  
+          }
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = this->filterIDoutputs_pair.size() ;
+        }
+
+
+
         nbOperationDates ++;
         if (!copyLess)
@@ -117,8 +119,103 @@
 
         isFirstOperation = false;
+        
+        packet->field = this->field;
         if(building_graph) packet->src_filterID=this->filterID;
+        if(building_graph) this->filterIDoutputs_pair.clear();
+        if(building_graph) CWorkflowGraph::build_begin=true;
+      }
+    }
+
+    return packet;
+  }
+
+
+
+  CDataPacketPtr CTemporalFilter::apply_old(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph=this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+   
+    if(building_graph)
+    {
+      if(this->filterIDoutputs.size()==0) this->filterID = InvalidableObject::filterIdGenerator++;
+      int edgeID = InvalidableObject::edgeIdGenerator++;
+      
+      // std::cout<<"CTemporalFilter::apply filter tag = "<<this->tag<<" start = "<<this->start_graph<<" end = "<<this->end_graph<<std::endl;
+
+      CWorkflowGraph::allocNodeEdge();
+
+      if(this->filterIDoutputs.size()==0)
+      {
+        CWorkflowGraph::addNode(this->filterID, "Temporal Filter\\n("+this->temp_op+")", 5, 1, 0, data[0]);   
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].transform_type = this->temp_op;   
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].inputs_complete = false ;
+      }
+
+      if(CWorkflowGraph::build_begin)
+      {
+
+        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb += 1 ;
+      }
+
+
+      this->filterIDoutputs.push_back(data[0]->src_filterID); 
+    }
+    
+    
+    CDataPacketPtr packet;
+
+    if (data[0]->status != CDataPacket::END_OF_STREAM)
+    {
+      bool usePacket, outputResult, copyLess;
+      if (isOnceOperation)
+        usePacket = outputResult = copyLess = isFirstOperation;
+      else
+      {
+        usePacket = (data[0]->date >= nextSamplingDate);
+        outputResult = (data[0]->date  > initDate + nbOperationDates*opFreq - samplingFreq + offsetMonth + offsetAllButMonth);
+        copyLess = (isInstantOperation && usePacket && outputResult);
+      }
+
+      if (usePacket)
+      {
+        nbSamplingDates ++;
+        if (!copyLess)
+        {
+          if (!tmpData.numElements())
+            tmpData.resize(data[0]->data.numElements());
+
+          (*functor)(data[0]->data);
+        }
+
+        nextSamplingDate = ((initDate + offsetMonth) + nbSamplingDates * samplingFreq) + offsetAllButMonth + initDate.getRelCalendar().getTimeStep();
+      }
+
+      if (outputResult)
+      {
+        nbOperationDates ++;
+        if (!copyLess)
+        {
+          functor->final();
+
+          packet = CDataPacketPtr(new CDataPacket);
+          packet->date = data[0]->date;
+          packet->timestamp = data[0]->timestamp;
+          packet->status = data[0]->status;
+          packet->data.resize(tmpData.numElements());
+          packet->data = tmpData;
+        }
+        else
+          packet = data[0];
+
+        isFirstOperation = false;
+        
         packet->field = this->field;
+        if(building_graph) packet->src_filterID=this->filterID;
         if(building_graph) this->filterIDoutputs.clear();
         if(building_graph) CWorkflowGraph::build_begin=true;
+        if(building_graph) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].inputs_complete = true ;
       }
     }
Index: XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.hpp	(revision 1680)
@@ -40,4 +40,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      CDataPacketPtr virtual apply_old(std::vector<CDataPacketPtr> data);
 
       /*!
@@ -54,5 +55,8 @@
        */
       bool virtual isDataExpected(const CDate& date) const;
-      std::vector<int> filterIDoutputs;
+      std::vector<int > filterIDoutputs;
+      std::vector<std::pair<int, int> > filterIDoutputs_pair;
+
+      StdString temp_op;
 
     private:
Index: XIOS/dev/dev_trunk_omp/src/filter/ternary_arithmetic_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/ternary_arithmetic_filter.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/ternary_arithmetic_filter.cpp	(revision 1680)
@@ -1,4 +1,5 @@
 #include "ternary_arithmetic_filter.hpp"
 #include "workflow_graph.hpp"
+#include "yacc_var.hpp"
 
 namespace xios
@@ -9,5 +10,8 @@
     , value1(value1)
     , value2(value2)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
 
   CDataPacketPtr CScalarScalarFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -20,15 +24,11 @@
        int edgeID = InvalidableObject::edgeIdGenerator++;
     
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+      CWorkflowGraph::allocNodeEdge();
 
       std::cout<<"CScalarScalarFieldArithmeticFilter::apply connection = "<<data[0]->src_filterID<<" <-> "<<this->filterID<<std::endl;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "SSF Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+
+
+      CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 1, data[0]);
 
 
@@ -61,5 +61,8 @@
     , value1(value1)
     , value2(value2)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
 
   CDataPacketPtr CScalarFieldScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -73,15 +76,11 @@
     
 
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+      CWorkflowGraph::allocNodeEdge();
 
       std::cout<<"CScalarFieldScalarArithmeticFilter::apply connection = "<<data[0]->src_filterID<<" <-> "<<this->filterID<<std::endl;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "SFS Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+
+
+      CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 1, data[0]);
 
       if(CWorkflowGraph::build_begin)
@@ -111,5 +110,8 @@
     , op(operatorExpr.getOpScalarFieldField(op))
     , value(value)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
 
   CDataPacketPtr CScalarFieldFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -123,15 +125,10 @@
     
 
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+      CWorkflowGraph::allocNodeEdge();
 
       std::cout<<"CScalarFieldFieldArithmeticFilter::apply connection = "<<data[0]->src_filterID<<" <-> "<<this->filterID<<std::endl;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "SFF Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+
+      CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 2, data[0]);
 
       if(CWorkflowGraph::build_begin)
@@ -177,5 +174,8 @@
     , value1(value1)
     , value2(value2)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
 
   CDataPacketPtr CFieldScalarScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -189,15 +189,9 @@
     
 
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+      CWorkflowGraph::allocNodeEdge();
 
       std::cout<<"CFieldScalarScalarArithmeticFilter::apply connection = "<<data[0]->src_filterID<<" <-> "<<this->filterID<<std::endl;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "FSS Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+      CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 1, data[0]);
 
       if(CWorkflowGraph::build_begin)
@@ -229,5 +223,8 @@
     , op(operatorExpr.getOpFieldScalarField(op))
     , value(value)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
 
   CDataPacketPtr CFieldScalarFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -241,15 +238,9 @@
     
 
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+      CWorkflowGraph::allocNodeEdge();
 
       std::cout<<"CFieldScalarFieldArithmeticFilter::apply connection = "<<data[0]->src_filterID<<" <-> "<<this->filterID<<std::endl;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "FSF Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+      CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 2, data[0]);
 
       if(CWorkflowGraph::build_begin)
@@ -291,5 +282,9 @@
     , op(operatorExpr.getOpFieldFieldScalar(op))
     , value(value)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    std::cout<<"expression = "<<expression;
+    /* Nothing to do */ 
+  };
 
   CDataPacketPtr CFieldFieldScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -302,15 +297,10 @@
       int edgeID = InvalidableObject::edgeIdGenerator++;
     
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+      CWorkflowGraph::allocNodeEdge();
 
       std::cout<<"CFieldFieldScalarArithmeticFilter::apply connection = "<<data[0]->src_filterID<<" <-> "<<this->filterID<<std::endl;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "FFS Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+
+      CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 2, data[0]);
 
       if(CWorkflowGraph::build_begin)
@@ -352,5 +342,8 @@
     : CFilter(gc, 3, this)
     , op(operatorExpr.getOpFieldFieldField(op))
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
 
   CDataPacketPtr CFieldFieldFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -364,15 +357,10 @@
     
 
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+      CWorkflowGraph::allocNodeEdge();
 
       std::cout<<"CFieldFieldFieldArithmeticFilter::apply connection = "<<data[0]->src_filterID<<" <-> "<<this->filterID<<std::endl;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "FFF Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 3;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+
+      CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 3, data[0]);
 
       if(CWorkflowGraph::build_begin)
Index: XIOS/dev/dev_trunk_omp/src/filter/unary_arithmetic_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/unary_arithmetic_filter.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/unary_arithmetic_filter.cpp	(revision 1680)
@@ -1,4 +1,7 @@
 #include "unary_arithmetic_filter.hpp"
 #include "workflow_graph.hpp"
+#include "yacc_var.hpp"
+#include "file.hpp"
+
 namespace xios
 {
@@ -7,23 +10,5 @@
     , op(operatorExpr.getOpField(op))
   { 
-    StdString input_op_expression=op;
-    if(input_op_expression == "neg")
-      op_expression = "-";
-    else if(input_op_expression == "sin")
-      op_expression = "sin";
-    else if(input_op_expression == "cos")
-      op_expression = "cos";
-    else if(input_op_expression == "tan")
-      op_expression = "tan";
-    else if(input_op_expression == "exp")
-      op_expression = "exp";
-    else if(input_op_expression == "log")
-      op_expression = "log";
-    else if(input_op_expression == "log10")
-      op_expression = "log10";
-    else if(input_op_expression == "sqrt")
-      op_expression = "sqrt";
-    else
-      op_expression = " ";
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
   };
 
@@ -31,30 +16,49 @@
   {
     bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
-
+    int unique_filter_id;
+    
     if(building_graph)
     {
-      this->filterID = InvalidableObject::filterIdGenerator++;
-      int edgeID = InvalidableObject::edgeIdGenerator++;
+      CWorkflowGraph::allocNodeEdge();
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->recordXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->recordXiosAttributes();
       
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+        if(CWorkflowGraph::build_begin)
+        {
 
-      std::cout<<"CunaryArithmeticFilter::apply filter tag = "<<this->tag<<std::endl;
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "F Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+        }
+        else CWorkflowGraph::build_begin = true;
 
-      if(CWorkflowGraph::build_begin)
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+      }
+      else 
       {
-
-        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
-
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
-      }
-      else CWorkflowGraph::build_begin = true;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]); 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+      
+        
+      } 
   
     }
@@ -69,7 +73,8 @@
       packet->data.reference(op(data[0]->data));
 
-    if(building_graph) packet->src_filterID = this->filterID;
+    if(building_graph) packet->src_filterID = unique_filter_id;
 
     return packet;
   }
 } // namespace xios
+
